/*
University of Sao Paulo - Institute of Mathematics and Computer Science ( ICMC - USP )
Computer Graphics - SCC 0250
Developer (PAE): Vinicius Ruela Pereira Borges
Profa: Maria Cristina Ferreira de Oliveira

Codigo 6 - Primitivas 3D
CODE 6 - 3D Primitives

> Para compilar este codigo, execute no terminal do Linux - To compile this code, type the following command on Linux Terminal

# gcc primitives3D.c  -lX11 -lglut -lGL -lGLU -lm -o primitives3D

Para executar o codigo, digite - To run this code, type:

# ./primitives3D

*/

//Bibliotecas - Libraries

// Biblioteca de entrada e saida padrao de dados
#include <stdio.h>
// Biblioteca GL: Contem as funcoes padroes do OpenGl
#include <GL/gl.h>
// Biblioteca GLU : Rotinas que utilizam os comandos OpenGL de baixo nivel para executar tarefas
#include <GL/glu.h>
// Biblioteca GLUT : Criacao de janelas e tratamento de eventos de forma independente do sistema operacional
#include <GL/glut.h>

#include <stdlib.h>

int window;

// Funcao que prepara a janela onde a cena grafica sera desenhada
void InitGL(int width, int height) {
  
    //Ajusta a cor de fundo para branco
    glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
    
    // Ativa teste de profundidade
    glEnable(GL_DEPTH_TEST);
    
    // Carrega a matriz de transformacoes
    glMatrixMode(GL_MODELVIEW);
    
    // Coloca a matriz identidade 
    glLoadIdentity(); 
    
    // Carrega a matriz de projecao
    glMatrixMode(GL_PROJECTION);

    // Define projecao ortogonal que mapeia o poligono nas coordenadas do mundo para coordenadas da tela
    glOrtho(-5.0f,5.0f,-5.0f,5.0f,-5.0f,5.0f);
    
}


// Funcao que desenha a cena grafica na tela
void DrawGLScene() {
  
    // Limpa a tela e o Depth Buffer
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    // Armazena estado atual da pilha de transformações
    glPushMatrix();

    // Desenho da piramide
    glBegin(GL_POLYGON);
	// Face frontal da piramide
	glColor3f(0.0f,0.0f,1.0f);
	glVertex3f(0.0f, 1.0f, 0.0f);	// vertice superior
	glVertex3f(-1.0f,-1.0f, 1.0f);	// vertice esquerdo
	glVertex3f(1.0f,-1.0f, 1.0f);	// vertice direito

	// Face da direita da piramide
	glColor3f(0.0f,1.0f,0.0f);
	glVertex3f( 0.0f, 1.0f, 0.0f); // vertice superior
	glVertex3f( 1.0f,-1.0f, 1.0f);   // vertice esquerdo
	glVertex3f( 1.0f,-1.0f, -1.0f);  // vertice direito

	// back face of pyramid
	glColor3f(0.0f,0.0f,0.0f); 
	glVertex3f( 0.0f, 1.0f, 0.0f);   // vertice superior
	glVertex3f( 1.0f,-1.0f, -1.0f);    // vertice esquerdo
	glVertex3f(-1.0f,-1.0f, -1.0f);    // vertice da direita

	// left face of pyramid.
	glColor3f(1.0f,0.0f,0.0f); 
	glVertex3f( 0.0f, 1.0f, 0.0f);   // vertice superior
	glVertex3f(-1.0f,-1.0f,-1.0f);    // vertice da esquerda
	glVertex3f(-1.0f,-1.0f, 1.0f);    // vertice da direita
	
	// Fazer a base da piramide!!!
    glEnd();
    
    // Restaura estado anterior da matriz de transformações
    glPopMatrix();

    // Processa as rotinas do OpenGL o mais rapido possi­vel
    glFlush();

    // Rotina glut que redesenha a cena grafica na tela
    glutPostRedisplay();
}


main(int argc, char *argv[])
{

    //Inicializa o Glut
    glutInit(&argc, argv);

    // Ajusta o display para o usuario
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB | GLUT_DEPTH);

    //Coordenada inicial da janela
    glutInitWindowPosition(0, 0);

    //Ajusta o tamanho da janela com 640x480
    glutInitWindowSize(640, 480);

    //Nome da Janela
    window = glutCreateWindow("3D Primitives");

    //Funcao que prepara a cena grafica na janela com dimensoes 640 x 480
    InitGL(640, 480);

    //Desenha a cena grafica na tela
    glutDisplayFunc(DrawGLScene);
    
    //Loop de atualizacao da tela
    glutMainLoop();

    return 0;
}
